Create a follower
- PUT /{index}/_ccr/follow
Create a cross-cluster replication follower index that follows a specific leader index. When the API returns, the follower index exists and cross-cluster replication starts replicating operations from the leader index to the follower index.
Path Parameters
-
indexstring IndexNamerequired -
The name of the follower index.
Query Parameters
-
master_timeoutstring Duration · default: 30s Period to wait for a connection to the master node.
-
wait_for_active_shardsWaitForActiveShards · default: 0 Specifies the number of shards to wait on being active before responding. This defaults to waiting on none of the shards to be active. A shard must be restored from the leader index before being active. Restoring a follower shard requires transferring all the remote Lucene segment files to the follower index.
-
Values:
allindex-setting
Request
-
data_stream_namestring -
If the leader index is part of a data stream, the name to which the local data stream for the followed index should be renamed.
-
leader_indexstring IndexNamerequired -
The name of the index in the leader cluster to follow.
-
max_outstanding_read_requestsnumber -
The maximum number of outstanding reads requests from the remote cluster.
-
max_outstanding_write_requestsnumber -
The maximum number of outstanding write requests on the follower.
-
max_read_request_operation_countnumber -
The maximum number of operations to pull per read from the remote cluster.
-
max_read_request_sizenumber | string ByteSize -
The maximum size in bytes of per read of a batch of operations pulled from the remote cluster.
-
max_retry_delaystring Duration -
The maximum time to wait before retrying an operation that failed exceptionally. An exponential backoff strategy is employed when retrying.
-
max_write_buffer_countnumber -
The maximum number of operations that can be queued for writing. When this limit is reached, reads from the remote cluster will be deferred until the number of queued operations goes below the limit.
-
max_write_buffer_sizenumber | string ByteSize -
The maximum total bytes of operations that can be queued for writing. When this limit is reached, reads from the remote cluster will be deferred until the total bytes of queued operations goes below the limit.
-
max_write_request_operation_countnumber -
The maximum number of operations per bulk write request executed on the follower.
-
max_write_request_sizenumber | string ByteSize -
The maximum total bytes of operations per bulk write request executed on the follower.
-
read_poll_timeoutstring Duration -
The maximum time to wait for new operations on the remote cluster when the follower index is synchronized with the leader index. When the timeout has elapsed, the poll for operations will return to the follower so that it can update some statistics. Then the follower will immediately attempt to read from the leader again.
-
remote_clusterstringrequired -
The remote cluster containing the leader index.
-
settingsIndexSettings -
Settings to override from the leader index.
Response
-
follow_index_createdbooleanrequired -
follow_index_shards_ackedbooleanrequired -
index_following_startedbooleanrequired